import React, { Component } from 'react';
import { connect } from 'react-redux';
import {
    View
} from 'native-base';

import { Colors } from '../colors';
import {
    Dimensions
} from 'react-native';
const { width, height } = Dimensions.get('window');

class Nubs extends Component {
    constructor(props) {
        super(props);
        this.state = {
            size: { width, height },
        };
    }
    _onLayoutDidChange = (e) => {
        const layout = e.nativeEvent.layout;
        this.setState({ size: { width: layout.width, height: layout.height } });
    }

    render() {
        var me = this;
        var choices = [].interpolate(0, this.props.count, e => { return {} });
        return (<View onLayout={this._onLayoutDidChange.bind(this)} style={{
            flexDirection: 'row', flex: 1, justifyContent: 'center',
            alignItems: 'center',
            alignContent: 'center', width
        }}>
            {choices.map((choice, i) => {
                var size = me.props.size;
                let color = null;
                var el;
                if (me.props.active.indexOf(i) !== -1) {
                    size = 10;
                    color = this.props.activecolor || Colors.White;
                    if (me.props.activeElement) {
                        el = me.props.activeElement(`choiceindex-${i}`);
                    }
                }
                else {
                    size = 7;
                    color = this.props.inactive || Colors.Grey;
                    if (me.props.inActiveElement) {
                        el = me.props.inActiveElement(`choiceindex-${i}`);
                    }
                }
                if (el) {
                    return el;
                }
                return (<View style={{ padding: me.props.padding || 0 }} key={`choiceindex-${i}`}>{Circle(null, {
                    borderRadius: size,
                    backgroundColor: color,
                    width: size,
                    height: size,
                    ...(this.props.circleStyle || {})
                })}</View>);
            })}
        </View>)
    }
}

export const Circle = (children, style) => {
    return (
        <View style={style}>
            <View
                style={{
                    flex: 1,
                    alignItems: 'center',
                    flexDirection: 'column'
                }}>
                <View style={{
                    flex: 1,
                    alignItems: 'center',
                    flexDirection: 'row'
                }}>
                    {children}
                </View>
            </View>
        </View>
    )
}
export default Nubs; 