'use strict';
import React, { Component } from 'react';
import {
    AppRegistry,
    StyleSheet,
    WebView,
    View, AsyncStorage
} from 'react-native';
import { Actions } from 'react-native-router-flux';
import * as Titles from '../titles';
import * as UIA from '../actions/uiActions';
import * as Common from '../common';

import {
    Container,
    Header,
    Footer,
    FooterTab,
    Body,
    Spinner,
    Button,
    Content,
    List,
    ListItem,
    Text
} from 'native-base';
// Change these to reflect
export default class RedScreenListComponent extends Component {
    constructor(props) {
        super(props);
        this.state = {
            objectValue: null
        };
        if (this.getEndpointOverrides) {
            this.getEndpointOverrides = this.getEndpointOverrides.bind(this);
        }
    }
    componentDidMount() {
        var me = this;
        me.loadList();
        if (me.props.api) {
            me.props.api({
                loadList: function () {
                    me.loadList();
                }
            })
        }
    }
    loadList() {
        var me = this;
        me.setState({ loadingList: true });
        me.props.getRedObjectList(me.props.objectType, me.getEndpointOverrides, (list) => {
            me.setState({ loadingList: false });
            var func = me.props.onRedObjectList || me.onRedObjectList || (() => { });
            func(list);
        }, (e) => {
            me.setState({ loadingList: false });
            var func = me.props.onRedObjectListError || me.onRedObjectListError || (() => { });
            func(e);
        });
    }
    getText(item) {
        return null;
    }
    getListItem(item) {
        var me = this;
        var icon = me.getItemIcon(item);
        return (
            Common.ListButtonItem(icon, me.getText(item), me.getItemAction(item), me.getItemBody(item), me.getItemRight(item), me.getKey(item), me.getItemNote(item))
        )
    }
    getFooter() {
        return null;
    }
    getKey(item) {
        return item ? item.id : null;
    }
    getItemAction(item) {
        return () => { };
    }
    getItemRight(item) {
        return null;
    }
    getItemBody() {
        return null;
    }
    getItemNote() {
        return null;
    }
    getRightHeader() {
        return null;
    }
    getTopContent() {
        return null;
    }
    getTopListItem() {
        return null;
    }
    getLeftHeader() {
        return Common.BackButton();
    }

    getEmptyList(){
        return (Common.EmptyList());
    }
    render() {
        var me = this;
        var { state } = me.props;
        var ui = UIA.GetC(state, UIA.UI_DEFINIONS, me.props.objectType);
        var items = UIA.GetC(state, UIA.OBJECT_LISTS, me.props.objectType);
        items = (items || this.props.items || []);
        if (this.props.listOnly) {
            return (
                <List>
                    {me.getTopListItem()}
                    {
                        items.length ? items.map(item => {
                            return me.getListItem(item);
                        }) : (me.getEmptyList())
                    }</List>
            )
        }
        return (
            <Container>
                <Header>
                    {me.getLeftHeader()}
                    {Common.HeaderTitle(me.props.title)}
                    {me.getRightHeader()}
                </Header>
                <Content>
                    {me.getTopContent()}
                    <List>
                        {me.getTopListItem()}
                        {
                            items.length ? items.map(item => {
                                return me.getListItem(item);
                            }) : (Common.EmptyList())
                        }</List>
                </Content>
                {UIA.GetC(state, UIA.LOADING_OBJECT_LISTS, me.props.objectType) ? Common.WaitingFooter() : me.getFooter()}
            </Container>
        )
    }
}

const styles = ({
});
